#ifndef MUSICOBJECT_H
#define MUSICOBJECT_H

#include <QObject>
#include "musiclibrary_global.h"

/**
 * Base class for Artist, Record and Song.
 * Name property is common to all three types.
 */
class MUSICLIBRARYSHARED_EXPORT MusicObject : public QObject
{
    Q_OBJECT

public:

    /**
     * Destructor is public so object can be deleted
     */
    virtual ~MusicObject();

    /**
     * Sets object name (NOTE: Not same as QObject::setObjectName())
     */
    void setName(const QString &name);

    /**
     * Gets object name (NOTE: Not same as QObject::objectName())
     */
    QString name() const;

protected:

    /**
     * Constructor is not public, as this is never directly created
     */
    MusicObject(QObject *parent);
};

#endif // MUSICOBJECT_H
